wok annotate syslinux/stuff/iso2exe/init @ rev 21506

Update some web_site
author Pascal Bellard <pascal.bellard@slitaz.org>
date Thu May 02 18:27:43 2019 +0200 (6 months ago)
parents ada21ebe1860
children daaaf5face8a
rev   line source
pascal@21302 1 #!/bin/sh
pascal@13691 2
pascal@13691 3 DIALOG=dialog
pascal@13691 4
pascal@17454 5 ddq()
pascal@17454 6 {
pascal@17454 7 dd $@ 2> /dev/null
pascal@17454 8 }
pascal@17454 9
pascal@13691 10 get()
pascal@13691 11 {
pascal@17496 12 od -v -j $1 -N ${4:-${3:-2}} -t u${3:-2} -w${3:-2} -An $2 2>/dev/null ||
pascal@21460 13 hexdump -v -s $1 -n ${4:-${3:-2}} -e "\"\" 1/${3:-2} \" %u\n\"" $2
pascal@13691 14 }
pascal@13691 15
pascal@13691 16 getarg()
pascal@13691 17 {
pascal@13691 18 sed "/$1=/!d;s/.*$1=\\([^ ]*\\).*/\\1/" /proc/cmdline
pascal@13691 19 }
pascal@13691 20
pascal@17489 21 clear()
pascal@17489 22 {
pascal@17489 23 echo -e "\x1B[1;1H\x1B[J"
pascal@17489 24 }
pascal@17489 25
pascal@17569 26 xless()
pascal@17569 27 {
pascal@17569 28 [ $(wc -l < "$1") -gt 22 ] &&
pascal@17569 29 sed 's/..3.;4.m/===/g;$s/.*/&\n---\nPress q to continue/' "$1" | less ||
pascal@17569 30 { cat "$1"
pascal@17569 31 [ "$2" ] || return
pascal@17569 32 echo -e "$2"
pascal@17569 33 read n
pascal@17569 34 }
pascal@17569 35 }
pascal@17569 36
pascal@17489 37 tinydialog()
pascal@17489 38 {
pascal@17489 39 clear
pascal@17489 40 label=""
pascal@17489 41 while [ "$1" ]; do
pascal@17489 42 case "$1" in
pascal@17489 43 --title) title=" \x1B[30;47m$2\x1B[37;40m\n"
pascal@17489 44 echo -e $title; shift ;;
pascal@17489 45 --yes-label) label="$2" ; shift ;;
pascal@17489 46 --textbox)
pascal@17569 47 xless "$2" "\nPress RETURN to continue."
pascal@17489 48 break;;
pascal@17489 49 --gauge)
pascal@17489 50 t=" "
pascal@17489 51 echo -e "$t$2\n"
pascal@17489 52 while read pct ; do
pascal@17489 53 s=" "
pascal@17489 54 s="$s$pct%$s"
pascal@17489 55 pct=$((($pct*63)/100))
pascal@17489 56 echo -en "\r$t\x1B[30;47m$(echo "$s" | cut -c-$pct)\x1B[37;40m$(echo "$s" | cut -c$(($pct+1))-)"
pascal@17489 57 done
pascal@17489 58 break;;
pascal@17489 59 --yesno)
pascal@17489 60 while true; do
pascal@17489 61 clear
pascal@17491 62 echo "$2" | sed 's/\\n\\n/\\n/g;s/\\n/\n/g'
pascal@17491 63 echo -en " <- 1:${label:-Yes} 2:Cancel\r"
pascal@17489 64 read x
pascal@17489 65 case "$x" in
pascal@17489 66 ''|Y*|y*|1) return 0;;
pascal@17489 67 N*|n*|2|0) return 1;;
pascal@17489 68 esac
pascal@17489 69 done ;;
pascal@17489 70 --menu|--radiolist)
pascal@20891 71 [ "$1" = "--menu" ] && shft=2 || shft=3
pascal@17491 72 label=""
pascal@20771 73 [ "$2" ] && label="\n$2"
pascal@17489 74 shift 5
pascal@17491 75 echo -e "$title$label\n0 Cancel" > /tmp/data
pascal@17489 76 n=1
pascal@17489 77 while [ "$1" ]; do
pascal@17489 78 eval key_$n='$1'
pascal@17489 79 echo "$((n++)) $2"
pascal@17491 80 shift $shft
pascal@17489 81 done >> /tmp/data
pascal@17489 82 while ! grep -q "^$n " /tmp/data ; do
pascal@17489 83 clear
pascal@17569 84 xless /tmp/data
pascal@17489 85 echo -en "\n <- Enter the selection number\r"
pascal@17489 86 read n
pascal@17489 87 done 2> /dev/null
pascal@17489 88 rm -f /tmp/data
pascal@17489 89 [ $n -eq 0 ] && return 1
pascal@17489 90 eval echo -n \$key_$n 1>&2
pascal@17489 91 return 0;;
pascal@17489 92 esac
pascal@17489 93 shift
pascal@17489 94 done
pascal@17489 95 }
pascal@17489 96
pascal@16041 97 mount_proc()
pascal@16041 98 {
pascal@16041 99 mount -t proc /proc /proc
pascal@16041 100 mount -t sysfs /sys /sys
pascal@16041 101 udevd --daemon 2> /dev/null && udevadm trigger && sleep 5
pascal@16041 102 }
pascal@16041 103
pascal@16041 104 umount_proc()
pascal@16041 105 {
pascal@16041 106 killall udevd 2> /dev/null
pascal@16041 107 umount /sys/fs/fuse/connections 2> /dev/null
pascal@16041 108 umount /sys
pascal@16041 109 umount /proc
pascal@16041 110 }
pascal@16041 111
pascal@17473 112 bytes2bin()
pascal@17473 113 {
pascal@17473 114 for i in $@ ; do
pascal@17569 115 printf '\\\\x%02X' $(($i&255))
pascal@17569 116 done | xargs echo -en
pascal@17473 117 }
pascal@17473 118
pascal@17454 119 words2bin()
pascal@17454 120 {
pascal@17454 121 for i in $@ ; do
pascal@17569 122 printf '\\\\x%02X\\\\x%02X' $(($i&255)) $((($i>>8)&255))
pascal@17569 123 done | xargs echo -en
pascal@17454 124 }
pascal@17454 125
pascal@13691 126 gettazboot()
pascal@13691 127 {
pascal@21506 128 echo -e "\nCreating $(basename $1) ..."
pascal@21472 129 X=$(($(get 20 /mnt/$ISO) - 0xC0))
pascal@21472 130 [ $X -lt 30000 ] && X=$((0x7FF0))
pascal@17810 131 O=$(($(get 64 /mnt/$ISO) - 0xC0))
pascal@21472 132 L=$(($X - $(get 24 /mnt/$ISO) - $O))
pascal@13691 133 S=$((32+$L))
pascal@13691 134 P=$((($S+511)/512))
pascal@13691 135 E=$((4096-(32*$P)))
pascal@17454 136 words2bin 0x5A4D $(($S%512)) $P 0 2 $E -1 $((${2:-0}-16)) \
pascal@17454 137 -2 0 256 -16 28 0x6C53 0x5469 0x7A61 > $1
pascal@21472 138 ddq bs=1 count=$(echo $L) skip=$(echo $O) if=/mnt/$ISO >> $1
pascal@13691 139 }
pascal@13691 140
pascal@13691 141 checkmagic()
pascal@13691 142 {
pascal@20891 143 [ -s $1 ] && [ $(getarg magic) = $(get 18 $1 2) ]
pascal@13691 144 }
pascal@13691 145
pascal@13691 146 getiso()
pascal@13691 147 {
pascal@13713 148 mkdir -p /media/cdrom
pascal@17489 149 for dev in /sys/block/?d?/?d??* ; do
pascal@17489 150 mount /dev/$(basename $dev) /mnt
pascal@13713 151 if checkmagic /mnt/$ISO; then
pascal@13713 152 mount -o loop,ro /mnt/$ISO /media/cdrom
pascal@17489 153 echo "Found $ISO on $(basename $dev)"
pascal@19510 154 return 0
pascal@13713 155 fi
pascal@13713 156 umount /mnt
pascal@19510 157 done 2> /dev/null
pascal@19510 158 return 1
pascal@13691 159 }
pascal@13691 160
pascal@13691 161 uncpio()
pascal@13691 162 {
pascal@17489 163 [ -s "$1" ] || return
pascal@17476 164 echo -en "\n Extracting $(basename $1) ..."
pascal@13699 165 case $(get 0 $1) in
pascal@17160 166 *35615) ( zcat || gunzip ) ;;
pascal@17476 167 *14333) unxz ;;
pascal@17160 168 *\ 93) unlzma ;;
pascal@17160 169 *) cat ;;
pascal@17160 170 esac < $1 | ( cd ${2:-/} ; cpio -idmu > /dev/null 2>&1 )
pascal@13691 171 }
pascal@13691 172
pascal@17476 173 dotwait()
pascal@17476 174 {
pascal@17476 175 echo -n "${1:-Install filesystem}.."
pascal@21363 176 echo -n > /tmp/wait
pascal@17476 177 while [ -e /tmp/wait ]; do
pascal@17476 178 echo -n "." > /dev/tty0
pascal@17476 179 sleep 1
pascal@17476 180 done &
pascal@17476 181 }
pascal@17476 182
pascal@13691 183 getuuid()
pascal@13691 184 {
pascal@13691 185 dev=$(mount | sed '/ \/mnt /!d;s/ .*//;s|/dev/||;q')
pascal@16041 186 blkid | sed "/$dev:/!d;s/.* UUID=.\\([^ ]*\\)\".*/\\1/"
pascal@13691 187 }
pascal@13691 188
pascal@16055 189 tazusbinitfs()
pascal@16055 190 {
pascal@16055 191 PAD=$(($(stat -c %s $1) % 4))
pascal@17454 192 [ $PAD -ne 0 ] && ddq if=/dev/zero bs=1 count=$((4 - $PAD)) >> $1
pascal@16055 193 mkdir -p /tmp/fs/etc /tmp/fs/lib /tmp/fs/home
pascal@16055 194 cp -a /etc/locale.conf /tmp/fs/etc 2> /dev/null
pascal@16055 195 cp -a /etc/keymap.conf /tmp/fs/etc 2> /dev/null
pascal@16055 196 sed 's/ .*//' /proc/modules | while read mod ; do
pascal@16055 197 find /lib/modules/ | grep $mod.ko | \
pascal@16055 198 sed 's|.*|cp & /tmp/fs/lib|' | sh
pascal@16055 199 done
pascal@16055 200 cat > /tmp/fs/init1 <<EOT
pascal@16055 201 #!/bin/sh
pascal@16055 202 sed -i 's|sbin/init|init2|' /init
pascal@16055 203 exec /init
pascal@16055 204 EOT
pascal@16055 205 cat > /tmp/fs/init2 <<EOT
pascal@16055 206 #!/bin/sh
pascal@16055 207
pascal@16055 208 mount -t proc /proc /proc
pascal@16055 209 for i in /lib/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
pascal@16055 210 v=\$(sed '/\\/home=/!d;s|.*/home=\\([^ ]*\\).*|\\1|' /proc/cmdline /cmdline 2> /dev/null)
pascal@16055 211 mount / -o remount,rw
pascal@16055 212 mkdir /mnt/dos
pascal@16055 213 rm -f /cmdline 2> /dev/null
pascal@16055 214 mount / -o remount,ro
pascal@16055 215 mnt=/mnt/dos/\${v#*/}
pascal@16055 216 dev=\$( (blkid /dev/[sh]d* || blkid) | grep \${v%%/*} | sed 's/:.*//;q')
pascal@16055 217 echo "Mount \$dev in /mnt/dos for \$v..." | tee -a /run/boot.log
pascal@16055 218 mount \$dev /mnt/dos
pascal@16055 219 mount.posixovl -F \$mnt -- -oallow_other -odefault_permissions -osuid
pascal@16055 220 mount --bind \$mnt /home
pascal@21506 221 mount -o size=0,ro -t tmpfs tmpfs \$mnt
pascal@16055 222 umount /proc
pascal@16055 223 exec /sbin/init
pascal@16055 224 EOT
pascal@16055 225 chmod 755 /tmp/fs/init?
pascal@16055 226 cp -a /tmp/fs/* /
pascal@16055 227 ( cd /tmp/fs ; find * | cpio -o -H newc ) | gzip -9 >> $1
pascal@16055 228 }
pascal@16055 229
pascal@13691 230 mkinitrd()
pascal@13691 231 {
pascal@21472 232 echo
pascal@17476 233 dotwait "Creating $(basename $1) "
pascal@13691 234 for i in bin lib dev proc tmp mnt etc ; do
pascal@13691 235 mkdir -p /tmp/fs/$i
pascal@13691 236 done
pascal@21506 237 for i in /dev/console /dev/null /dev/tty /dev/tty[012] /dev/fuse /dev/[hs]d* ; do
pascal@13691 238 cp -a $i /tmp/fs$i
pascal@13691 239 done
pascal@13713 240 for i in /bin/busybox $(which mount.posixovl) $(which blkid); do
pascal@13691 241 cp $(LD_TRACE_LOADED_OBJECTS=1 /lib/ld*.so $i | \
pascal@13691 242 sed 's|.*=> \(.*/lib/l[^ ]*\).*|\1|;/^\//!d') /tmp/fs/lib
pascal@13691 243 cp $i /tmp/fs/bin
pascal@13691 244 done
pascal@13691 245 cp -a /lib/ld-* /tmp/fs/lib
pascal@13691 246 for i in $(busybox | sed '/Current/,$!d'); do
pascal@14271 247 [ -e /tmp/fs/bin/${i%,} ] || ln -s busybox /tmp/fs/bin/${i%,}
pascal@13691 248 done
pascal@13691 249 ln -s /proc/mounts /tmp/fs/etc/mtab
pascal@16041 250 sed 's/ .*//' /proc/modules | while read mod ; do
pascal@16041 251 find /lib/modules/ | grep $mod.ko | \
pascal@16041 252 sed 's|.*|cp & /tmp/fs/lib|' | sh
pascal@16041 253 done
pascal@13691 254 cat > /tmp/fs/init <<EOT
pascal@13691 255 #!/bin/sh
pascal@13691 256
pascal@13691 257 arg()
pascal@13691 258 {
pascal@13691 259 grep -q \$1 /proc/cmdline &&
pascal@13691 260 val="\$(sed "s/.*\$1=\\([^ ]*\\).*/\\1/" < /proc/cmdline)" &&
pascal@13691 261 echo "\$2 \$val"
pascal@13691 262 }
pascal@13691 263
pascal@13691 264 mount -t proc /proc /proc
pascal@16055 265 for i in /lib/*.ko* ; do insmod \$i 2> /dev/null ; done; sleep 2
pascal@13691 266 arg mount "Mount device"
pascal@16055 267 mount \$( (blkid /dev/[sh]d* || blkid) | grep \$val | sed 's/:.*//;q') /mnt
pascal@13691 268 arg subroot "Change root to directory"
pascal@16041 269 mount.posixovl -F /mnt/\$val -- -oallow_other -odefault_permissions -osuid
pascal@13691 270 mount --bind /mnt /mnt/\$val/mnt/dos
pascal@21472 271 mount -o size=0,ro -t tmpfs tmpfs /mnt/\$val/mnt/dos/\$val
pascal@13691 272 LDSO=\$(ls /mnt/\$val/lib/ld-* | sed q)
pascal@16041 273 export LD_LIBRARY_PATH=\$val/lib:\$val/usr/lib:/lib
pascal@13691 274 umount /proc
pascal@13691 275 exec /bin/switch_root /mnt \${LDSO#/mnt/} \$val/usr/sbin/chroot \$val /sbin/init
pascal@13691 276 EOT
pascal@13691 277 chmod +x /tmp/fs/init
pascal@13691 278 ( cd /tmp/fs ; find * | cpio -o -H newc ) | lzma e $1 -si 2> /dev/null
pascal@17476 279 rm -rf /tmp/fs /tmp/wait
pascal@13691 280 }
pascal@13691 281
pascal@13713 282 is_loram()
pascal@13713 283 {
pascal@21459 284 [ -s /lib/modules/squashfs.ko* ]
pascal@13713 285 }
pascal@13713 286
pascal@16041 287 ls_r()
pascal@16041 288 {
pascal@16041 289 ls -r $@ 2> /dev/null || ls $@
pascal@16041 290 }
pascal@16041 291
pascal@13691 292 doinstall()
pascal@13691 293 {
pascal@14271 294 mkdir -p /mnt/slitaz/boot /mnt/slitaz/mnt/dos
pascal@16041 295 if ! mount.posixovl -F /mnt/slitaz -- \
pascal@16041 296 -oallow_other -odefault_permissions -osuid; then
pascal@16041 297 echo "Can't install SliTaz. Abort."
pascal@16041 298 sleep 5
pascal@16041 299 return 1
pascal@16041 300 fi
pascal@17635 301 dotwait "Install root filesystem in /slitaz.."
pascal@17454 302 if [ "$1" ]; then
pascal@14271 303 if [ -d /media/cdrom/fs ]; then
pascal@14271 304 ( cd /mnt/slitaz/fs; find | cpio -o -H newc ) | gzip -9
pascal@14271 305 else
pascal@17635 306 ls_r /media/cdrom/boot/rootfs*gz | xargs cat
pascal@14271 307 fi > /mnt/slitaz/boot/rootfs.gz
pascal@16055 308 tazusbinitfs /mnt/slitaz/boot/rootfs.gz
pascal@14271 309 initrd=rootfs.gz
pascal@16055 310 extraargs="/home=$(getuuid)/slitaz rdinit=/init1"
pascal@13713 311 else
pascal@14271 312 if [ -d /media/cdrom/fs ]; then
pascal@14271 313 cp -a /media/cdrom/fs/. /mnt/slitaz
pascal@14271 314 elif is_loram ; then
pascal@17635 315 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@21506 316 losetup -o 124 /dev/loop7 $i
pascal@21506 317 mount -t squashfs -o ro /dev/loop7 /sqfs/mnt
pascal@14271 318 cp -a /sqfs/mnt/. /mnt/slitaz
pascal@21506 319 umount /sqfs/mnt
pascal@21506 320 losetup -d /dev/loop7
pascal@14271 321 done
pascal@14271 322 else
pascal@17635 323 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@14271 324 uncpio $i /mnt/slitaz
pascal@14271 325 done
pascal@14271 326 fi
pascal@14271 327 mkinitrd /mnt/slitaz/boot/initrd
pascal@14271 328 initrd=initrd
pascal@14271 329 extraargs="mount=$(getuuid) subroot=slitaz"
pascal@13713 330 fi
pascal@17476 331 echo -en "\nInstall boot files..."
pascal@13691 332 for i in /media/cdrom/boot/bzImage /media/cdrom/boot/*pxe* \
pascal@13691 333 /media/cdrom/boot/isolinux/he* /media/cdrom/boot/isolinux/opt* \
pascal@13691 334 /media/cdrom/README /media/cdrom/boot/memtest* ; do
pascal@13691 335 [ -s $i ] && cp $i /mnt/slitaz/boot
pascal@13691 336 done
pascal@21472 337 for i in /mnt/slitaz/boot/memtest /mnt/slitaz/boot/*pxe ; do
pascal@16047 338 [ $(get 0 $i 2> /dev/null || echo 0) -eq 23117 ] &&
pascal@16047 339 mv $i $i.exe
pascal@16047 340 done
pascal@21506 341 cp /etc/keymap.conf /etc/locale.conf /mnt/slitaz/etc 2> /dev/null
pascal@13691 342 gettazboot /mnt/slitaz/boot/tazboot.exe
pascal@14247 343 unix2dos > /mnt/slitaz/boot/tazboot.cmd <<EOT
pascal@16041 344 kernel=/slitaz/boot/bzimage
pascal@16041 345 initrd=/slitaz/boot/$initrd
pascal@14271 346 rw root=/dev/null $extraargs autologin
pascal@13691 347 EOT
pascal@13691 348 unix2dos /mnt/slitaz/boot/he* /mnt/slitaz/boot/opt* \
pascal@14247 349 /mnt/slitaz/boot/README
pascal@14271 350 [ -d /mnt/slitaz/usr/sbin -a ! -x /mnt/slitaz/usr/sbin/mount.posixovl ] &&
pascal@13713 351 cp $(which mount.posixovl) /mnt/slitaz/usr/sbin
pascal@17476 352 rm -f /tmp/wait
pascal@16041 353 false &&
pascal@17476 354 [ -s /mnt/boot.ini ] && ! grep -qs tazboot /mnt/boot.ini &&
pascal@17476 355 echo "Update boot.ini ..." && unix2dos >> /mnt/boot.ini <<EOT
pascal@13691 356 C:\\slitaz\\boot\\tazboot.exe="SliTaz"
pascal@13691 357 EOT
pascal@16073 358 false &&
pascal@16073 359 grep -qis menuitem /mnt/config.sys && ! grep -qi tazboot /mnt/config.sys &&
pascal@16041 360 echo "Update config.sys ..." &&
pascal@16073 361 sed -i 's/menudefault/menuitem SLITAZ, SliTaz\r\n&/' /mnt/config.sys &&
pascal@16073 362 unix2dos >> /mnt/config.sys <<EOT
pascal@16073 363 [SLITAZ]
pascal@16073 364 install=\\slitaz\\boot\\tazboot.exe
pascal@13691 365 EOT
pascal@16041 366 return 0
pascal@13691 367 }
pascal@13691 368
pascal@13691 369 install()
pascal@13691 370 {
pascal@20771 371 $DIALOG --clear --title " SliTaz UMSDOS way installation " \
pascal@13691 372 --yes-label "Install" --yesno \
pascal@13691 373 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
pascal@13691 374 DOS/Windows partition. You will see your files from /mnt/dos.\n\n
paul@13692 375 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
pascal@13691 376 To uninstall SliTaz, you have only to remove this directory.
pascal@13691 377 The file \\boot.ini or \\config.sys may be modified too.\n\n
pascal@20771 378 SliTaz may run slowly on the 'UMSDOS way' installation due to the
paul@14320 379 posixovl filesystem. The 'TAZUSB way' installation runs faster.\n\n
pascal@13697 380 To do a traditional installation with disk partitioning,
pascal@20771 381 start SliTaz Live with the 'SliTaz RAM boot' menu.\n" 19 70
pascal@14271 382 [ $? -eq 0 ] || return
pascal@16041 383 doinstall || return
pascal@16041 384 [ -x /mnt/slitaz/sbin/init ] || return
pascal@14271 385 umount -d /media/cdrom
pascal@16041 386 umount_proc
pascal@13691 387 exec chroot /mnt/slitaz /sbin/init
pascal@13691 388 }
pascal@13691 389
pascal@14271 390 installtaz()
pascal@14271 391 {
pascal@20771 392 $DIALOG --clear --title " SliTaz TAZUSB way installation " \
pascal@14271 393 --yes-label "Install" --yesno \
pascal@14271 394 "\nSliTaz will be installed in the subdirectory \\slitaz of the current
pascal@14271 395 DOS/Windows partition. You will see your files from /mnt/dos.\n\n
pascal@14271 396 You can start SliTaz with \\slitaz\\boot\\tazboot.exe\n\n
pascal@14271 397 To uninstall SliTaz, you have only to remove this directory.
pascal@14271 398 The file \\boot.ini or \\config.sys may be modified too.\n\n
pascal@14271 399 The filesystem is loaded entirely into memory upon boot to
paul@19451 400 increase responsiveness. Only /home lands on the hard disk.\n\n
pascal@14271 401 To do a traditional installation with disk partitioning,
pascal@20771 402 start SliTaz Live with the 'SliTaz RAM boot' menu.\n" 19 70
pascal@14271 403 [ $? -eq 0 ] || return
pascal@16041 404 doinstall tazusblike || return
pascal@20771 405 dotwait
pascal@14271 406 if [ -d /media/cdrom/fs ]; then
pascal@16055 407 cp -a /media/cdrom/fs/. /
pascal@14271 408 else
pascal@17635 409 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@17454 410 uncpio $i
pascal@14271 411 done
pascal@14271 412 fi
pascal@16055 413 cp /tmp/fs/etc/* /etc
pascal@16055 414 echo "/home=$(getuuid)/slitaz" > /cmdline
pascal@17476 415 rm -f /tmp/wait
pascal@16055 416 [ -x /init1 ] || return
pascal@14271 417 umount -d /media/cdrom
pascal@16055 418 umount /mnt/slitaz
pascal@16073 419 rm -f /dev/cdrom
pascal@16055 420 umount /mnt
pascal@16055 421 mkdir /mnt/dos
pascal@16041 422 umount_proc
pascal@16055 423 exec /init1
pascal@14271 424 }
pascal@14271 425
pascal@13691 426 tazboot()
pascal@13691 427 {
pascal@20771 428 $DIALOG --clear --title " SliTaz bootloader for DOS " \
pascal@13691 429 --yes-label "Install" --yesno \
paul@13692 430 "\nThe file TAZBOOT.EXE will be created in the top directory. It supports
pascal@17476 431 any linux kernel, multiple initramfs, a kernel command line and
paul@13692 432 an ISO image file loopback (retrieves files from an ISO file).\n\n
pascal@20771 433 Usage: tazboot.exe [[@commands]|[kernel=<bzimage>]
pascal@17489 434 [initrd=<rootfs>[,<rootfs2>...]] [bootfrom=<isofile>] cmdline args ...]\n\n
paul@13692 435 Defaults: tazboot @tazboot.cmd or tazboot kernel=bzImage auto\n\n\
pascal@13691 436 Examples for tazboot.cmd:\n\n\
pascal@17489 437 bootfrom=\\isos\\slitaz-4.0.iso\n\
pascal@13691 438 kernel=boot/bzImage\n\
pascal@13691 439 initrd=boot/rootfs4.gz,boot/rootfs3.gz,boot/rootfs2.gz,boot/rootfs1.gz\n\
pascal@13691 440 rw root=/dev/null autologin\n\n\
pascal@13691 441 kernel=\\slitaz\\vmlinuz root=/dev/sda5 ro\n\n
pascal@20771 442 Unlike GRUB4DOS, it doesn't require unfragmented ISO image files.\n" 24 78
pascal@13691 443 [ $? -eq 0 ] || return
pascal@13691 444 gettazboot /mnt/tazboot.exe
pascal@13691 445 }
pascal@13691 446
pascal@13697 447 md5()
pascal@13697 448 {
pascal@17476 449 dotwait "Checking files"
pascal@18061 450 ( cd /media/cdrom ; ${1:-md5sum -c md5sum*} | sort ) > /tmp/data
pascal@17476 451 rm -f /tmp/wait
pascal@20771 452 $DIALOG --clear --title " Checked files " --textbox /tmp/data 24 78
pascal@13697 453 rm -f /tmp/data
pascal@13697 454 }
pascal@13697 455
pascal@17491 456 gotcdfile()
pascal@17491 457 {
pascal@17635 458 for i in "/media/cdrom/$1" "/media/cdrom/*/$1" \
pascal@17635 459 "/media/cdrom/*/isolinux/$1" ; do
pascal@17491 460 file=$(ls $i 2> /dev/null | sed q)
pascal@17491 461 [ -s "$file" ] && break
pascal@17491 462 done
pascal@17491 463 }
pascal@17491 464
pascal@17489 465 sha()
pascal@17489 466 {
pascal@17635 467 gotcdfile "sha*sum*"
pascal@17489 468 sha=$(basename $file)
pascal@17489 469 md5 "${sha%sum*}sum -c ${file#/media/cdrom/}"
pascal@17489 470 }
pascal@17489 471
pascal@13697 472 readme()
pascal@13697 473 {
pascal@17635 474 gotcdfile "README*"
pascal@20771 475 $DIALOG --clear --title " Readme " --textbox $file 24 78
pascal@13697 476 }
pascal@13697 477
pascal@13697 478 bootlog()
pascal@13697 479 {
pascal@20771 480 $DIALOG --clear --title " Linux boot messages " \
pascal@13697 481 --textbox /tmp/dmesg 24 78
pascal@13697 482 }
pascal@13697 483
pascal@17476 484 bzimage()
pascal@17476 485 {
pascal@20771 486 $DIALOG --clear --title " Create linux.exe ? " \
pascal@17476 487 --yes-label "Install" --yesno \
pascal@17476 488 "\nLinux.exe launches the linux kernel under DOS (in real mode only).
pascal@17569 489 The cmdline arguments are supported except initrd=,
pascal@17569 490 vga= (you can try 'rdev -v') and mem= (partially).
pascal@17569 491 \nExample:\nC:\\> linux.exe root=/dev/hda2 ro panic=60\n
pascal@17476 492 " 12 70
pascal@17476 493 [ $? -eq 0 ] || return
pascal@17476 494 cp /media/cdrom/boot/bzImage /mnt/linux.exe
pascal@17476 495 }
pascal@17476 496
pascal@13697 497 memtest()
pascal@13697 498 {
pascal@20771 499 $DIALOG --clear --title " Create memtest.exe ? " \
pascal@13697 500 --yes-label "Install" --yesno \
pascal@13697 501 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
pascal@13697 502 computers. BIOS based memory tests are a quick, cursory check and often
pascal@20771 503 miss many of the failures that are detected by Memtest86.\n" 12 70
pascal@17635 504 [ $? -eq 0 ] && gotcdfile "memtest*" && cp $file /mnt/memtest.exe
pascal@13697 505 }
pascal@13697 506
pascal@17489 507 mkfat12()
pascal@17473 508 {
pascal@17473 509 [ $(($(get 0 $1) - 0x5A4D)) -eq 0 ] || return
pascal@17473 510 J=$(($(get 3 $1 1) + 0x02))
pascal@17473 511 R=$((1 + $(get 497 $1 1) + 1 + ($(get 500 $1)-1)/32))
pascal@17473 512 [ $R -lt 2500 ] || return
pascal@17476 513 [ $((($(get 500 $1)-1) & 31)) -lt 30 ] &&
pascal@17474 514 ddq if=$file bs=32 count=1 seek=$(($R*16 - 1)) of=/dev/fd0
pascal@17473 515 G="18 0 2 0 0 0 0 0"
pascal@17473 516 [ $J -gt 25 ] || G=""
pascal@17473 517 F=0
pascal@17473 518 for i in 1 2 3; do
pascal@17473 519 F=$((((2880-$R-$F-$F)*3+1023)/1024))
pascal@17473 520 done
pascal@17473 521 bytes2bin 0xEB $J 0x90 0x20 0x20 0x20 0x20 0x20 0x20 0x20 0x20 \
pascal@17473 522 0 2 2 $(($R%256)) $(($R/256)) 2 64 0 64 11 0xF0 $F 0 \
pascal@17473 523 $G | ddq bs=1 of=/dev/fd0
pascal@17473 524 ddq if=/dev/zero bs=512 count=$((4+$F+$F)) seek=$R of=/dev/fd0
pascal@17473 525 for i in $R $(($R+$F)) ; do
pascal@17473 526 bytes2bin 0xF0 0xFF 0xFF | ddq bs=512 seek=$i of=/dev/fd0
pascal@17473 527 done
pascal@17473 528 echo -n $(basename $1) | ddq bs=1 seek=3 count=8 of=/dev/fd0
pascal@17489 529 }
pascal@17489 530
pascal@17489 531 mkfloppy()
pascal@17489 532 {
pascal@21485 533 dotwait "Create a $(basename $1 .exe) boot floppy"
pascal@17489 534 ddq if=$1 of=/dev/fd0
pascal@17489 535 mkfat12 $1
pascal@17476 536 rm -f /tmp/wait
pascal@17473 537 }
pascal@17473 538
pascal@13697 539 fdmemtest()
pascal@13697 540 {
pascal@20771 541 $DIALOG --clear --title " Create a Memtest86 boot floppy " \
pascal@13697 542 --yes-label "Create floppy" --yesno \
pascal@13697 543 "\nMemtest86 is a thorough, stand alone memory test for x86 architecture
pascal@13697 544 computers. BIOS based memory tests are a quick, cursory check and often
pascal@13697 545 miss many of the failures that are detected by Memtest86.\n\n
pascal@20771 546 Please insert a blank disk in floppy drive.\n" 12 70
pascal@17635 547 [ $? -eq 0 ] && gotcdfile "memtest*" && mkfloppy $file
pascal@13697 548 }
pascal@13697 549
pascal@16013 550 pxe()
pascal@13697 551 {
pascal@20762 552 gotcdfile "?pxe*"
pascal@21485 553 $DIALOG --clear --title " Create $(basename $file .exe).exe ? " \
pascal@13697 554 --yes-label "Install" --yesno \
pascal@13697 555 "\nBoot your operating system from the internet and enjoy a full system
pascal@13697 556 working entirely in RAM with speed and stability in mind. The Linux Kernel
pascal@13697 557 and the complete SliTaz compressed root filesystem will be loaded into RAM
pascal@20771 558 from the Web using PXE and HTTP protocols.\n" 12 70
pascal@13697 559 [ $? -eq 0 ] || return
pascal@21485 560 cp $file /mnt/$(basename $file .exe).exe
pascal@13697 561 }
pascal@13697 562
pascal@16013 563 fdpxe()
pascal@13697 564 {
pascal@20771 565 $DIALOG --clear --title " Create a SliTaz Web boot floppy " \
pascal@13697 566 --yes-label "Create floppy" --yesno \
pascal@13697 567 "\nBoot your operating system from the internet and enjoy a full system
pascal@13697 568 working entirely in RAM with speed and stability in mind. The Linux Kernel
pascal@13697 569 and the complete SliTaz compressed root filesystem will be loaded into RAM
pascal@13697 570 from the Web using PXE and HTTP protocols.\n\n
pascal@20771 571 Please insert a blank disk in floppy drive.\n" 12 70
pascal@20762 572 [ $? -eq 0 ] && gotcdfile "?pxe*" && mkfloppy $file
pascal@13697 573 }
pascal@13697 574
pascal@16041 575 gotposixovl()
pascal@16041 576 {
pascal@20771 577 mount.posixovl 2>&1 | grep -qi usage &&
pascal@16041 578 echo -en "\"$1\" \"$2\""
pascal@16041 579 }
pascal@16041 580
pascal@14271 581 xfile()
pascal@14271 582 {
pascal@17454 583 [ "$(which $1)" ] && echo -en "\"$2\" \"$3\""
pascal@14271 584 }
pascal@14271 585
pascal@13697 586 cdfile()
pascal@13697 587 {
pascal@17489 588 gotcdfile "$1" && echo -en "\"$2\" \"$3\""
pascal@17476 589 }
pascal@17476 590
pascal@17659 591 isbzImage()
pascal@17659 592 {
pascal@17659 593 [ $(get 514 $file 4) -eq 1400005704 ] &&
pascal@17659 594 [ $(($(get 529 $file 1) & 1)) -eq 1 ]
pascal@17659 595 }
pascal@17659 596
pascal@17476 597 cdfilex()
pascal@17476 598 {
pascal@17659 599 gotcdfile "$1" &&
pascal@17659 600 [ "$(which kexec)" ] &&
pascal@17659 601 isbzImage &&
pascal@17659 602 echo -en "\"$2\" \"$3\""
pascal@14271 603 }
pascal@14271 604
pascal@17491 605 cdfilef()
pascal@17491 606 {
pascal@17491 607 [ -e /sys/block/fd0 ] && cdfile "$@"
pascal@17491 608 }
pascal@17491 609
pascal@16022 610 cdexe()
pascal@16022 611 {
pascal@17489 612 gotcdfile "$1" &&
pascal@17489 613 [ $(get 0 $file 2>/dev/null || echo 0) -eq 23117 ] &&
pascal@16022 614 echo -en "\"$2\" \"$3\""
pascal@16022 615 }
pascal@16022 616
pascal@14271 617 fddata()
pascal@14271 618 {
pascal@20771 619 [ -e /sys/block/fd0 ] &&
pascal@18771 620 [ $(get 26 /mnt/$ISO 1 2> /dev/null || echo 0) -ne 0 ] &&
pascal@14271 621 echo -en "\"$1\" \"$2\""
pascal@13697 622 }
pascal@13697 623
pascal@17491 624 ishybrid()
pascal@17491 625 {
pascal@19510 626 [ $(get 510 $ISO 2> /dev/null || echo 0) -eq 43605 ] || return
pascal@17491 627 C=$((2048*$(get $(((17*2048) + 71)) /mnt/$ISO 4)))
pascal@17491 628 [ $(get $C /mnt/$ISO 4) -eq 1 ] || return
pascal@17491 629 [ $(get $(($C+30)) /mnt/$ISO 4) -eq $((0x88AA55)) ] || return
pascal@17491 630 C=$((2048*$(get $(($C+40)) /mnt/$ISO 4)))
pascal@17491 631 [ $(get $(($C+64)) /mnt/$ISO 4) -eq 1886961915 ] &&
pascal@17491 632 echo -en "\"$1\" \"$2\""
pascal@17491 633 }
pascal@17491 634
pascal@18034 635 burnable()
pascal@18034 636 {
pascal@19510 637 [ "$(sed '/Can wr.*1$/!d' /proc/sys/dev/cdrom/info 2> /dev/null)" ] &&
pascal@18034 638 [ "$(which wodim)" ] && echo -en "\"$1\" \"$2\""
pascal@18034 639 }
pascal@18034 640
pascal@18034 641 blankable()
pascal@18034 642 {
pascal@19510 643 [ "$(sed '/Can wr.*RW.*1$/!d' /proc/sys/dev/cdrom/info 2> /dev/null)" ] &&
pascal@18034 644 [ "$(which wodim)" ] && echo -en "\"$1\" \"$2\""
pascal@18034 645 }
pascal@18034 646
pascal@18034 647 burniso()
pascal@18034 648 {
pascal@18034 649 wodim -v speed=$(fgrep "drive speed" /proc/sys/dev/cdrom/info | cut -f3) \
pascal@18034 650 -eject -multi "$ISO"
pascal@18034 651 }
pascal@18034 652
pascal@18034 653 blankcd()
pascal@18034 654 {
pascal@18034 655 wodim -v -blank=fast
pascal@18034 656 }
pascal@18034 657
pascal@18771 658 customsector()
pascal@18771 659 {
pascal@19324 660 echo $(get 32848 "/mnt/$ISO" 4)
pascal@18771 661 }
pascal@18771 662
pascal@18771 663 hascustomconf()
pascal@18771 664 {
pascal@18771 665 [ "$(ddq bs=2k skip=$(customsector) if="/mnt/$ISO" | ddq bs=1 count=6)" \
pascal@20891 666 = "#!boot" ]
pascal@18771 667 }
pascal@18771 668
pascal@18771 669 gotcustomconf()
pascal@18771 670 {
pascal@18774 671 hascustomconf && echo -en "\"$1\" \"$2\""
pascal@18771 672 }
pascal@18771 673
pascal@18771 674 getcustomconf()
pascal@18771 675 {
pascal@18774 676 cd ${1:-/mnt}
pascal@18774 677 ddq bs=2k skip=$(customsector) if="/mnt/$ISO" | while read line; do
pascal@18771 678 case "$line" in
pascal@18771 679 \#!boot*) ;;
pascal@18771 680 append=*) echo ${line#append=} > cmdline && ls -l cmdline ;;
pascal@18771 681 initrd:*) cnt=${line#initrd:}
pascal@18771 682 { ddq bs=512 count=$(($cnt / 512));
pascal@18771 683 ddq bs=1 count=$(($cnt % 512)); } > initrd &&
pascal@18771 684 ls -l initrd
pascal@18771 685 break ;;
pascal@20771 686 *) break ;;
pascal@18771 687 esac
pascal@18771 688 done
pascal@18771 689 cd - > /dev/null
pascal@18774 690 [ -z "$1" ] && echo -e "\rPress RETURN to continue." && read n
pascal@18771 691 }
pascal@18771 692
pascal@17492 693 gotisomd5()
pascal@17492 694 {
pascal@17562 695 [ "$(which md5sum 2> /dev/null)" ] &&
pascal@17635 696 [ $(get 0 /mnt/$ISO) -eq 23117 ] &&
pascal@17635 697 [ $(get 18 /mnt/$ISO) -ne 0 ] && echo -en "\"$1\" \"$2\""
pascal@17492 698 }
pascal@17492 699
pascal@17492 700 isomd5()
pascal@17492 701 {
pascal@17492 702 dotwait "Checking iso image"
pascal@17635 703 [ "$(ddq if=/mnt/$ISO bs=2k skip=16 \
pascal@20891 704 count=$(($(get 32848 /mnt/$ISO 4)-16)) | md5sum)" = \
pascal@17635 705 "$(ddq if=/mnt/$ISO bs=16 count=1 skip=2047 | od -N 16 -t x1 -An | \
pascal@17496 706 sed 's/ //g') -" ] && echo "OK" || echo "ERROR"
pascal@17635 707 echo -en "\rChecking iso hybrid boot..."
pascal@17635 708 n=$(($(get 2 /mnt/$ISO)-1+($(get 4 /mnt/$ISO)-1)*512))
pascal@17635 709 if [ $n -lt 40000 -a $n -gt 32768 ]; then
pascal@17635 710 s=$(get 0 /mnt/$ISO 2 $n | awk '{ i+= $0 } END { print i }')
pascal@17635 711 [ $(((1+$s+$(get $(($n+1)) /mnt/$ISO 1)) % 65536)) -eq 0 ] &&
pascal@17635 712 echo "OK" || echo "ERROR"
pascal@17635 713 fi
pascal@18771 714 if hascustomconf; then
pascal@18771 715 echo -en "\rChecking iso custom config..."
pascal@18771 716 TMP=/tmp/$(basename $0)$$md5
pascal@18771 717 md5="$(ddq bs=2k skip=$(customsector) if=/mnt/$ISO | while read line; do
pascal@18771 718 case "$line" in
pascal@18771 719 \#!boot*) echo ${line#*boot } > $TMP ;;
pascal@18771 720 append=*) echo $line ;;
pascal@18771 721 initrd:*) echo $line
pascal@18771 722 cnt=${line#initrd:}
pascal@18771 723 ddq bs=512 count=$((cnt / 512))
pascal@18771 724 ddq bs=1 count=$((cnt % 512))
pascal@18771 725 break ;;
pascal@20771 726 *) break ;;
pascal@18771 727 esac
pascal@18771 728 done | md5sum | cut -c1-32)"
pascal@20891 729 [ "$md5" = "$(cat $TMP)" ] && echo "OK" || echo "ERROR"
pascal@18771 730 rm -f $TMP
pascal@18771 731 fi
pascal@17492 732 rm -f /tmp/wait
pascal@17562 733 echo -e "\rPress RETURN to continue."
pascal@17496 734 read n
pascal@17492 735 }
pascal@17492 736
pascal@20891 737 if [ "$1" = "--build" ]; then #install-begin
pascal@20763 738 cp $0 $0.tmp
pascal@20763 739 uuencode -m - < ifmem.bin | sed -e 's|^[ \t]*||;s|[ \t]*###.*||' \
pascal@20771 740 -e 's| *;;|;;|;s|\t\t*|\t|g' \
pascal@20763 741 -e '/^ifmemcode$/r/dev/stdin' -e '/^ifmemcode$/d' -i $0.tmp
pascal@18771 742 uuencode -m - < bootloader.bin | sed -e '/^bootloader$/r/dev/stdin' \
pascal@20764 743 -e '/^bootloader$/d' -e '/install-begin$/,/install-end$/d' -i $0.tmp
pascal@20763 744 mv -f $0.tmp $0; exit
pascal@18771 745 fi #install-end
pascal@18771 746 parse_isolinux()
pascal@18771 747 {
pascal@18771 748 awk 'BEGIN { IGNORECASE=1 }
pascal@18771 749 function multi(n)
pascal@18771 750 {
pascal@18771 751 auto=$n
pascal@18771 752 for (--n; n < NF; n+=2) {
pascal@18771 753 s=$n
pascal@18771 754 if (s ~ /M$/) s = substr(s,0,length(s)-1)
pascal@18771 755 else s /= 1024
pascal@18771 756 sizes=int(s) " " sizes
pascal@18771 757 }
pascal@18771 758 next
pascal@18771 759 }
pascal@18771 760 {
pascal@18771 761 if ($1 == "LABEL") {
pascal@18771 762 label=$2
pascal@18771 763 if (auto == "") auto=label
pascal@18771 764 }
pascal@18771 765 if ($1 == "KERNEL" || $1 == "COM32") kernel[label]=$2
pascal@18771 766 if ($1 == "INITRD") initrd[label]=$2
pascal@18771 767 if ($1 == "APPEND") {
pascal@18771 768 i=2
pascal@18771 769 if (kernel[label] ~ "ifmem.c32") multi(3)
pascal@18771 770 if (kernel[label] ~ "c32box.c32") {
pascal@18771 771 if ($2 == "linux") { kernel[label]=$3; i=4 }
pascal@18771 772 if ($2 == "ifmem") multi(4)
pascal@18771 773 }
pascal@18771 774 if (kernel[label] ~ "ifcpu64.c32") { auto=$4; next }
pascal@18771 775 while (i <= NF) {
pascal@18771 776 if ($i ~ "^initrd=") initrd[label]=substr($i,8)
pascal@18771 777 else cmdline[label]=cmdline[label] " " $i
pascal@18771 778 i++
pascal@18771 779 }
pascal@18771 780 }
pascal@18771 781 }
pascal@18771 782 END {
pascal@18771 783 print "KERNEL=\"" kernel[auto] "\""
pascal@18771 784 print "INITRD=\"" initrd[auto] "\""
pascal@18771 785 print "CMDLINE=\"" substr(cmdline[auto],2) "\""
pascal@18771 786 print "SIZES=\"" sizes "\""
pascal@18771 787 }'
pascal@18771 788 }
pascal@18771 789
pascal@18771 790 locase()
pascal@18771 791 {
pascal@18771 792 echo "$1" | tr [A-Z] [a-z]
pascal@18771 793 }
pascal@18771 794
pascal@18771 795 ifmemcode()
pascal@18771 796 {
pascal@18771 797 uudecode <<EOT
pascal@18771 798 ifmemcode
pascal@18771 799 EOT
pascal@18771 800 }
pascal@18771 801
pascal@18771 802 floppyset()
pascal@18771 803 {
pascal@18771 804 gotcdfile isolinux.cfg
pascal@18771 805 parse_isolinux < $file > /tmp/var$$
pascal@18771 806 . /tmp/var$$
pascal@19877 807 for i in /media/cdrom/$KERNEL $(dirname $file)/$KERNEL /media/cdrom/$(locase $KERNEL) \
pascal@18771 808 $(dirname $file)/$(locase $KERNEL); do
pascal@18771 809 [ -s $i ] && KERNEL=$i && break
pascal@18771 810 done
pascal@20771 811 rm -f /tmp/var$$
pascal@18771 812 [ $(get 514 $KERNEL 4) -eq 1400005704 ] || return
pascal@18771 813 n=$(($(get 497 $KERNEL 1)+1))
pascal@18771 814 ddq bs=512 count=$n if=$KERNEL of=/tmp/fd$$
pascal@18771 815 uudecode <<EOT | ddq of=/tmp/fd$$ conv=notrunc
pascal@18771 816 bootloader
pascal@18771 817 EOT
pascal@18771 818 pos=$(($n*512))
pascal@18771 819 if [ -n "$CMDLINE" ]; then
pascal@18771 820 echo -n "$CMDLINE" | ddq bs=512 count=1 conv=sync >> /tmp/fd$$
pascal@18771 821 bytes2bin $n | ddq conv=notrunc \
pascal@18771 822 bs=1 seek=497 count=1 of=/tmp/fd$$
pascal@18771 823 words2bin $pos | ddq conv=notrunc \
pascal@18771 824 bs=1 seek=34 count=2 of=/tmp/fd$$
pascal@18771 825 [ $(get 518 $KERNEL 4) -ge 514 ] &&
pascal@18771 826 words2bin 32768 9 | ddq conv=notrunc \
pascal@18771 827 bs=1 seek=552 count=4 of=/tmp/fd$$
pascal@18771 828 fi
pascal@18771 829 syssize=$(echo $(get 500 /tmp/fd$$ 4))
pascal@18771 830 ddq bs=512 skip=$n if=$KERNEL | cat - /dev/zero | \
pascal@18771 831 ddq bs=512 count=$((($syssize+31)/32)) conv=sync >> /tmp/fd$$
pascal@18771 832 base=$(stat -c %s /tmp/fd$$)
pascal@18771 833 len=
pascal@18771 834 if [ "$INITRD" ]; then
pascal@18771 835 l=0
pascal@18771 836 for i in ${INITRD//,/ }; do
pascal@19877 837 for j in /media/cdrom/$i $(dirname $KERNEL)/$i /media/cdrom/$(locase $i) \
pascal@18771 838 $(dirname $KERNEL)/$(locase $i); do
pascal@18771 839 [ -s $j ] && i=$j && break
pascal@18771 840 done
pascal@18771 841 ddq if=$i >> /tmp/fd$$
pascal@18771 842 l=$(($l+$(stat -c %s $i)))
pascal@18771 843 r=$((4 - ($l % 4)))
pascal@18771 844 if [ $r -ne 4 ]; then
pascal@18771 845 ddq if=/dev/zero bs=1 count=$r >> /tmp/fd$$
pascal@18771 846 l=$(($l + $r))
pascal@18771 847 fi
pascal@18771 848 case "$i:$INITRD" in
pascal@20762 849 *rootfs.gz:*rootfs.gz,*) continue ### loram
pascal@18771 850 esac
pascal@18771 851 len="$len $l"; l=0
pascal@18771 852 done
pascal@18771 853 rdadrs=${RDADRS:-$(((($syssize*16)+0x1F0000) & -4096))}
pascal@18771 854 words2bin $(($rdadrs & 0xFFFF)) $(($rdadrs >> 16)) | ddq \
pascal@18771 855 conv=notrunc bs=1 seek=536 count=4 of=/tmp/fd$$
pascal@18771 856 fi
pascal@18771 857 n=$(echo $len | wc -w)
pascal@18771 858 if [ $((494 - $(get 494 /tmp/fd$$))) -ge $(($n * 4)) ]; then
pascal@18771 859 i=$(($(get 494 /tmp/fd$$)))
pascal@18771 860 bytes2bin $(($i + ($n*4) - 256)) | ddq bs=1 conv=notrunc \
pascal@18771 861 seek=496 count=1 of=/tmp/fd$$
pascal@18771 862 else
pascal@18771 863 i=$(($pos + 0x1FC - ($n*4)))
pascal@18771 864 bytes2bin $(($i % 256)) $((i / 256)) 252 | ddq bs=1 \
pascal@18771 865 conv=notrunc seek=494 count=3 of=/tmp/fd$$
pascal@18771 866 s=$(($i - 2*$(echo "$SIZES" | wc -w)))
pascal@18771 867 p=$(($s - $(ifmemcode | wc -c)))
pascal@18771 868 ifmemcode | ddq bs=1 conv=notrunc seek=$p of=/tmp/fd$$
pascal@18771 869 words2bin $SIZES | ddq bs=1 conv=notrunc seek=$s of=/tmp/fd$$
pascal@18771 870 bytes2bin 154 $(($p%256)) $(($p/256)) 0 144 | \
pascal@18771 871 ddq bs=1 conv=notrunc seek=60 of=/tmp/fd$$
pascal@18771 872 fi
pascal@18771 873 for r in $len ; do
pascal@18771 874 words2bin $(($r & 0xFFFF)) $(($r >> 16)) | ddq conv=notrunc \
pascal@18771 875 bs=1 seek=$i count=4 of=/tmp/fd$$
pascal@18771 876 i=$(($i + 4))
pascal@18771 877 done
pascal@18771 878 split -b 1440k /tmp/fd$$ fd$$
pascal@18771 879 rm -f /tmp/fd$$
pascal@18771 880 n=1; i=0; r=0
pascal@18771 881 set -- $len
pascal@18771 882 ls fd$$* | while read file ; do
pascal@18771 883 if [ $i -gt $(($1+$base)) ]; then
pascal@18771 884 shift
pascal@18771 885 r=$(($r+100)); n=0; i=0; base=0
pascal@18771 886 fi
pascal@18771 887 ddq of=$file bs=18k seek=80 count=0
pascal@18771 888 i=$(($i+1474560))
pascal@18771 889 printf "mv %s fd%03d.img\n" $file $(($r+$n))
pascal@18771 890 n=$(($n+1))
pascal@18771 891 done | sh
pascal@18771 892 ls fd???.img
pascal@19878 893 mv fd???.img /mnt
pascal@18771 894 }
pascal@18771 895
pascal@14257 896 fdbootstrap()
pascal@14257 897 {
pascal@18771 898 sz=$((512 * $(echo $(get 26 /mnt/$ISO 1))))
pascal@20771 899 $DIALOG --clear --title " Create a floppy bootstrap " \
pascal@14271 900 --yes-label "Continue" --yesno \
paul@14263 901 "\nThe floppy will install a driver to access the ISO file
pascal@20771 902 on your hard disk and will emulate a CD-ROM during the boot process.\n\n
pascal@20771 903 Please insert a floppy in drive now.\n" 10 70
pascal@14271 904 [ $? -eq 0 ] || return
pascal@17474 905 ddq if=/mnt/$ISO of=/tmp/bootiso bs=1 count=512 \
pascal@17810 906 skip=$(( $(get 64 /mnt/$ISO) - $sz ))
pascal@17474 907 echo "$ISO" | ddq of=/tmp/bootiso bs=512 seek=1 count=1
pascal@17474 908 ddq if=/mnt/$ISO of=/tmp/bootiso bs=1 count=$sz seek=2 \
pascal@17810 909 skip=$(( $(get 64 /mnt/$ISO) - $sz + 512 ))
pascal@17474 910 mkfloppy /tmp/bootiso
pascal@17474 911 rm -f /tmp/bootiso
pascal@14257 912 }
pascal@14257 913
pascal@14257 914 usbdev()
pascal@14257 915 {
pascal@17476 916 dotwait "Wait 5 seconds for USB devices"
pascal@14257 917 sleep 5
pascal@17476 918 rm -f /tmp/wait
pascal@14257 919 DEV="$(grep -l 1 /sys/block/*/removable | \
pascal@14257 920 sed 's|/sys/block/\(.*\)/removable|\1|')"
pascal@17491 921 grep -qs 1 /sys/block/$DEV/ro && return
pascal@17454 922 [ "$DEV" ] || return
pascal@17491 923 cat > /tmp/dialog <<EOT
pascal@20778 924 $DIALOG --clear --title " Select your USB key " \
pascal@14257 925 --menu "\nPlease select the USB key according to its known size.\n\n" \
pascal@14257 926 14 70 4 \
pascal@14257 927 $(for i in $DEV ; do
pascal@17491 928 echo -n "/dev/$i \"$(($(cat /sys/block/$i/size)/2048))MB $(cat /sys/block/$i/device/model 2> /dev/null)\" "
pascal@20762 929 done)
pascal@17491 930 EOT
pascal@17491 931 exec 3>&1
pascal@17491 932 device=$(. /tmp/dialog 2>&1 1>&3)
pascal@14257 933 retval=$?
pascal@14257 934 exec 3>&-
pascal@14257 935 [ $retval -eq 0 ]
pascal@14257 936 }
pascal@14257 937
pascal@17491 938 tazusbmsg()
pascal@17491 939 {
pascal@17491 940 [ "$(which tazusb 2> /dev/null)" ] || return
pascal@17491 941 echo "You should choose 'USB key read/write installation' to be
pascal@17491 942 able to save the package updates or your own configuration and data files.\n\n"
pascal@17491 943 }
pascal@17491 944
pascal@14257 945 usbbootkey()
pascal@14257 946 {
pascal@20771 947 $DIALOG --clear --title " Create a USB boot key " \
pascal@14257 948 --yes-label "Continue" --yesno \
pascal@14257 949 "\nThe USB key will be used like a CD-ROM. You will not be able to write
pascal@17454 950 any data on the boot partition.\n\n
pascal@17454 951 An extra FAT32 partition will be created with the remaining free space.\n\n
pascal@20771 952 $(tazusbmsg)Please plug your USB stick in now.\n" 16 70
pascal@14257 953 [ $? -eq 0 ] || return
pascal@14257 954 usbdev || return
pascal@17454 955
pascal@20762 956 ### perform dd in progress bar
pascal@17491 957 max=$(($(cat /sys/block/loop0/size)/2048))
pascal@20771 958 i=0; ddq if=/mnt/$ISO bs=1024k | (
pascal@20771 959 while ddq bs=1024k count=1 ; do
pascal@17454 960 i=$(($i + 1))
pascal@17454 961 [ $i -gt $max ] && break
pascal@17455 962 echo $((($i*100)/$max)) | dialog --gauge \
pascal@17455 963 " The ISO image transfer can be long. Please wait..." \
pascal@17476 964 6 70 0 > /dev/tty0 2>&1
pascal@17454 965 done ) > $device
pascal@17454 966
pascal@20762 967 ### partition + fat32 format for the remaining space
pascal@17860 968 for p in 0 16; do
pascal@17860 969 get $((450+$p)) $device 2 12 | xargs echo | {
pascal@17860 970 read dx cx ol oh ll lh
pascal@17860 971 [ $dx -eq $((0x3F17)) ] || continue
pascal@17454 972 cx=$(($cx & 0xFF00))
pascal@17454 973 ofs=$(($ll+($lh<<16)))
pascal@17454 974 n=$(($(cat /sys/block/${device#/dev/}/size)-$ofs))
pascal@17454 975 m=$(($cx+($n/8)))
pascal@17454 976 [ $m -gt $((0x3FF00)) ] && m=$((0x3FF00))
pascal@17454 977 m=$((($m & 0xFF00)+(($m>>16)<<6)))
pascal@17454 978 words2bin 0 $((0x101+$cx)) 0x3F0B $((32+$m)) \
pascal@17454 979 $ll $lh $(($n & 0xFFFF)) $(($n >> 16)) | \
pascal@17860 980 ddq bs=1 seek=$((462-$p)) of=$device
pascal@17454 981 if [ "$(which mkdosfs 2> /dev/null)" ]; then
pascal@17562 982 losetup -o $((512*$ofs)) /dev/loop2 $device
pascal@17562 983 mkdosfs -n "SLITAZ BOOT" /dev/loop2
pascal@17454 984 words2bin $(($ofs & 0xFFFF)) $(($ofs >> 16)) | \
pascal@17562 985 ddq bs=1 seek=28 of=/dev/loop2
pascal@17860 986 sync
pascal@17562 987 losetup -d /dev/loop2
pascal@17454 988 fi
pascal@17860 989 }
pascal@17860 990 done
pascal@14257 991 }
pascal@14257 992
pascal@13697 993 usbkey()
pascal@13697 994 {
pascal@20771 995 $DIALOG --clear --title " Create a SliTaz USB key " \
pascal@13697 996 --yes-label "Continue" --yesno \
pascal@13697 997 "\nUnlike a hard drive install, the filesystem is kept in a compressed
pascal@13697 998 rootfs.gz. The filesystem is loaded entirely into memory upon boot.
pascal@13697 999 This should increase responsiveness, protect the filesystem against
pascal@13697 1000 accidental corruption and reduce read/writes to the USB drive.
pascal@13697 1001 Once setup, the tazusb utility can rewrite the root filesystem
pascal@20771 1002 with any changes you have made since booting up,
pascal@13697 1003 giving the effective benefits of a hard drive install.\n\n
pascal@13697 1004 /home is mounted on boot using the UUID of your particular flash drive.
pascal@13697 1005 Unlike a device name, the UUID has the benefit of never changing from machine
pascal@13697 1006 to machine.\n\n
pascal@20771 1007 Please plug your USB stick in now.\n" 19 70
pascal@14271 1008 [ $? -eq 0 ] || return
pascal@14257 1009 usbdev || return
pascal@13697 1010 exec 3>&1
pascal@20778 1011 format=`$DIALOG --clear --title " Select the filesystem " \
pascal@13733 1012 --radiolist "\nPlease select the filesystem type to create.\n\n\
paul@13698 1013 The filesystem creation will erase all the data \
pascal@13699 1014 in the USB key." 14 70 4 \
pascal@13733 1015 "none" "Do not erase the USB key" on \
pascal@13733 1016 "ext3" "Ext3 journaling filesystem" off \
pascal@13733 1017 "ext2" "Ext2 filesystem" off \
pascal@13733 1018 "fat32" "Windows FAT32 filesystem" off \
pascal@13697 1019 2>&1 1>&3`
pascal@13697 1020 retval=$?
pascal@13697 1021 exec 3>&-
pascal@14257 1022 [ $retval -eq 0 ] || return
pascal@13697 1023 [ "$format" != "none" ] && tazusb format $device "SliTaz" $format
pascal@13697 1024 tazusb gen-iso2usb /mnt/$ISO $device
pascal@13697 1025 }
pascal@13697 1026
pascal@13713 1027 mount_loram()
pascal@13713 1028 {
pascal@13713 1029 is_loram || return
pascal@21459 1030 insmod /lib/modules/squashfs.ko* 2> /dev/null
pascal@13713 1031 if [ -d /media/cdrom/fs ]; then
pascal@13713 1032 ln -s /media/cdrom/fs /sqfs
pascal@13713 1033 else
pascal@13713 1034 mkdir /sqfs
pascal@13713 1035 mount -o loop,ro -t squashfs /rootfs*.gz /sqfs
pascal@13713 1036 fi
pascal@21506 1037 cp -a /sqfs/dev/fuse /sqfs/dev/tty[12] /sqfs/dev/[hs]d* /dev
pascal@13713 1038 ln -s /sqfs/lib/* lib
pascal@21386 1039 ln -fs /sqfs/usr /sqfs/var /
pascal@21467 1040 mkdir /etc && cp /sqfs/etc/dialogrc /etc 2> /dev/null
pascal@13713 1041 }
pascal@13713 1042
pascal@13713 1043 umount_loram()
pascal@13713 1044 {
pascal@13713 1045 is_loram || return
pascal@20778 1046 rm /var /usr
pascal@13713 1047 umount -d /sqfs
pascal@21377 1048 rmdir /sqfs 2> /dev/null || rm -f /sqfs
pascal@13713 1049 }
pascal@13713 1050
pascal@17569 1051 dosync()
pascal@13691 1052 {
pascal@17569 1053 sync
pascal@13713 1054 umount_loram
pascal@13691 1055 umount -d /media/cdrom
pascal@16073 1056 rm -f /dev/cdrom
pascal@13691 1057 umount /mnt
pascal@16041 1058 umount_proc
pascal@17569 1059 }
pascal@17569 1060
pascal@17569 1061 text()
pascal@17569 1062 {
pascal@18774 1063 init=
pascal@18774 1064 cmdline="$(cat /proc/cmdline)"
pascal@18774 1065 if hascustomconf; then
pascal@18774 1066 getcustomconf /tmp > /dev/null
pascal@18774 1067 [ -s /tmp/cmdline ] &&
pascal@18774 1068 cmdline="$cmdline $(cat /tmp/cmdline)" &&
pascal@18774 1069 init="$(sed '/rdinit=/!d;s/.*rdinit=\([^ ]*\).*/\1/' < /tmp/cmdline)"
pascal@18774 1070 [ -s /tmp/initrd ] && uncpio /tmp/initrd
pascal@18774 1071 fi
pascal@17569 1072 dosync
pascal@18774 1073 exec ${init:-/init} $cmdline
pascal@13691 1074 }
pascal@13691 1075
pascal@13691 1076 live()
pascal@13691 1077 {
pascal@13691 1078 n=0
pascal@17476 1079 dotwait "Extract filesystem..."
pascal@17562 1080 for i in $(ls_r /media/cdrom/boot/rootfs*gz); do
pascal@17562 1081 grep -q ' lm ' /proc/cpuinfo && [ -s ${i}64 ] && i=${i}64
pascal@13691 1082 [ $((n++)) -eq 0 ] || uncpio $i
pascal@13691 1083 done
pascal@17476 1084 rm -f /tmp/wait
pascal@13691 1085 text
pascal@13691 1086 }
pascal@13691 1087
pascal@13713 1088 restart()
pascal@13691 1089 {
pascal@17476 1090 dosync
pascal@13713 1091 reboot -f
pascal@13691 1092 }
pascal@13691 1093
pascal@13713 1094 stop()
pascal@13691 1095 {
pascal@17476 1096 dosync
pascal@13713 1097 poweroff -f
pascal@13691 1098 }
pascal@13691 1099
pascal@17489 1100 dokexec()
pascal@17476 1101 {
pascal@17659 1102 kexec -l $file || return
pascal@17476 1103 dosync
pascal@17476 1104 kexec -e
pascal@17476 1105 }
pascal@17476 1106
pascal@17489 1107 runmemtest()
pascal@17489 1108 {
pascal@17635 1109 gotcdfile "memtest*" && dokexec
pascal@17489 1110 }
pascal@17489 1111
pascal@17476 1112 runpxe()
pascal@17476 1113 {
pascal@20762 1114 gotcdfile "?pxe*" && dokexec
pascal@17476 1115 }
pascal@17476 1116
pascal@17931 1117 flavdata()
pascal@17931 1118 {
pascal@20762 1119 [ $(get 1024 /mnt/$ISO) -eq 35615 ] && n=2 ||
pascal@20762 1120 n=$((1+$(get 417 /mnt/$ISO 1)))
pascal@20762 1121 [ $n -eq 4 ] && n=20
pascal@20762 1122 [ $(get $(($n*512)) /mnt/$ISO) -eq 35615 ] || n=13
pascal@20762 1123 ddq if=/mnt/$ISO bs=512 skip=$n count=20 | zcat 2>/dev/null
pascal@17931 1124 }
pascal@17931 1125
pascal@17931 1126 hasflavinfo()
pascal@17931 1127 {
pascal@20891 1128 [ "$(flavdata | ddq bs=1 count=7)" = "0707010" ] &&
pascal@19510 1129 echo -en "\"$1\" \"$2\""
pascal@17931 1130 }
pascal@17931 1131
pascal@17931 1132 showfavinfo()
pascal@17931 1133 {
pascal@17931 1134 mkdir -p /tmp/data
pascal@17931 1135 flavdata | ( cd /tmp/data ; cpio -i )
pascal@17931 1136 file=/tmp/data/info
pascal@17931 1137 cat /tmp/data/*desc > $file
pascal@17931 1138 for i in /tmp/data/*list* ; do
pascal@17931 1139 echo "=== extra ${i#*list} files"
pascal@17931 1140 cat $i
pascal@17931 1141 done >> $file
pascal@20771 1142 $DIALOG --clear --title " Flavor info " --textbox $file 24 78
pascal@17931 1143 rm -rf /tmp/data
pascal@17931 1144 }
pascal@17931 1145
pascal@18771 1146 flavor()
pascal@18771 1147 {
pascal@18771 1148 cd /mnt
pascal@18771 1149 name="$(flavdata | cpio -t 2> /dev/null | sed 's/.[a-z]*$//;q')"
pascal@18771 1150 echo "Create ${name:=flavor}.flavor..."
pascal@18771 1151 tazlito iso2flavor "/mnt/$ISO" $name
pascal@18771 1152 ls -l $name.flavor 2> /dev/null || sleep 5
pascal@18771 1153 cd - > /dev/null
pascal@18771 1154 }
pascal@18771 1155
pascal@13697 1156 shell()
pascal@13697 1157 {
pascal@20771 1158 trap text 2
pascal@21459 1159 getty -n -l /bin/ash 38400 tty1 2> /dev/null || sh
pascal@13697 1160 }
pascal@13697 1161
pascal@14247 1162 BIN=bin/mount.posixovl
pascal@14247 1163 [ -x /usr/s$BIN ] || mv /bin/mount.posixovl.iso2exe \
pascal@17489 1164 /usr/s$BIN 2> /dev/null || mv /bin/mount.posixovl.iso2exe /$BIN 2> /dev/null
pascal@16041 1165 mount_proc
pascal@18804 1166 for i in /sys/block/*/dev /sys/block/*/*/dev ; do
pascal@18804 1167 [ -s "$i" ] || continue
pascal@18804 1168 n=${i%/dev}
pascal@18804 1169 n=/dev/${n##*/}
pascal@18804 1170 [ -e $n ] && continue
pascal@18804 1171 mknod $n b $(sed 's/:/ /' < $i)
pascal@18804 1172 done
pascal@17489 1173 ISO="$(getarg bootfrom | sed 's/.://;s|\\|/|g')"
pascal@19510 1174 getiso || text 2> /dev/null
pascal@13713 1175 mount_loram
pascal@16041 1176 case "${ISO##*/}$(getarg mode)" in
pascal@16047 1177 *install*|*INSTALL*) install ;;
pascal@16047 1178 *live*|*LIVE*) live ;;
pascal@16047 1179 *text*|*TEXT*) text ;;
pascal@13691 1180 esac
pascal@17489 1181 which $DIALOG 2> /dev/null || DIALOG=tinydialog
pascal@13713 1182 dmesg > /tmp/dmesg
pascal@13691 1183
pascal@18778 1184 isotitle="$(blkid /mnt/$ISO | sed 's/.*LABEL="\([^"]*\).*/\1/') $(stat \
pascal@18778 1185 -c %y /media/cdrom | sed 's/ .*//') $(basename $ISO)"
pascal@13691 1186 while true; do
pascal@20771 1187 trap shell 2
pascal@16055 1188 keymap="$(cat /etc/keymap.conf 2> /dev/null)"
pascal@16055 1189 locale="$(sed '/^LANG=/!d;s/.*=//' /etc/locale.conf 2> /dev/null)"
pascal@14271 1190 cat > /tmp/dialog <<EOT
pascal@20778 1191 $DIALOG --clear --title " ${isotitle:-Welcome to Linux} " \
pascal@17454 1192 --menu "" 23 70 17 \
pascal@17489 1193 $(xfile tazkeymap "tazkeymap" "Select keyboard (${keymap:-none})") \
pascal@17489 1194 $(xfile tazlocale "tazlocale" "Select locale (${locale:-none})") \
pascal@17489 1195 $(cdfile boot/bzImage "live" "Linux RAM boot (full desktop)") \
pascal@17489 1196 "text" "Linux RAM boot" \
pascal@17635 1197 $(cdfile "README*" "readme" "Show the README file") \
pascal@18771 1198 $(gotcustomconf "getcustomconf" "Get custom config") \
pascal@17492 1199 $(gotisomd5 "isomd5" "Check the ISO image") \
pascal@17635 1200 $(cdfile "md5sum*" "md5" "Check the ISO files") \
pascal@17635 1201 $(cdfile "sha*sum*" "sha" "Check the ISO files") \
pascal@18034 1202 $(burnable "burniso" "Burn the ISO image") \
pascal@18034 1203 $(blankable "blankcd" "Blank the CD/DVD") \
pascal@16041 1204 $(gotposixovl "install" "Hard disk installation (UMSDOS way)") \
pascal@16041 1205 $(gotposixovl "installtaz" "Hard disk installation (TAZUSB way)") \
pascal@14271 1206 $(xfile tazusb "usbkey" "USB key read/write installation") \
pascal@17491 1207 $(ishybrid "usbbootkey" "USB boot key (read only)") \
paul@17935 1208 $(hasflavinfo "showfavinfo" "Show flavor extra info") \
pascal@18771 1209 $(xfile tazlito "flavor" "Get flavor file") \
pascal@17476 1210 $(fddata "fdbootstrap" "Create a floppy bootstrap") \
pascal@18771 1211 $(cdfile isolinux.cfg "floppyset" "Boot floppy set") \
pascal@17491 1212 "tazboot" "Get tazboot.exe Linux loader" \
pascal@17476 1213 $(cdexe boot/bzImage "bzimage" "Get linux DOS/EXE file") \
pascal@17635 1214 $(cdexe "memtest*" "memtest" "Get Memtest86 DOS/EXE file") \
pascal@17635 1215 $(cdfilef "memtest*" "fdmemtest" "Create a Memtest86 boot floppy") \
pascal@18771 1216 $(:||cdfilex "memtest*" "runmemtest" "Start Memtest86") \
pascal@20762 1217 $(cdexe "?pxe*" "pxe" "Get SliTaz Web boot DOS/EXE utility") \
pascal@20762 1218 $(cdfilef "?pxe*" "fdpxe" "Create a SliTaz Web boot floppy") \
pascal@20762 1219 $(:||cdfilex "?pxe*" "runpxe" "Start the SliTaz Web boot utility") \
pascal@14271 1220 $(xfile reboot "restart" "Restart the computer") \
pascal@14271 1221 $(xfile poweroff "stop" "Power off") \
pascal@13697 1222 "bootlog" "Linux boot messages" \
pascal@20762 1223 "shell" "Shell prompt"
pascal@14271 1224 EOT
pascal@14271 1225 exec 3>&1
pascal@17489 1226 value=$(. /tmp/dialog 2>&1 1>&3)
pascal@13691 1227 retval=$?
pascal@13691 1228 exec 3>&-
pascal@13691 1229 [ $retval -eq 0 ] || continue
pascal@13691 1230 $value
pascal@13691 1231 done